﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;

namespace HeuristicLab.PluginInfrastructure {
  [Serializable]
  public class UniPath {

    #region Vars
    private string fullPath = "";
    #endregion

    #region Constructors
    public UniPath(string path) {
      fullPath = Path.GetFullPath(path);
    }
    #endregion
    
    private bool IsWindowsAbsolutePath(string path) => Regex.IsMatch(path, @"^[A-Z]:");
    
    private string Rebuild(char split, string startStr, string seperator) {
      string[] splits = fullPath.Split(split);
      string tmp = startStr;
      int i = 1;
      while (i < splits.Length - 1) {
        tmp += splits[i] + seperator;
        ++i;
      }
      tmp += splits[i];
      return tmp;
    }

    public override string ToString() {
      bool isWindows = RuntimeInformation.IsOSPlatform(OSPlatform.Windows);
      if (isWindows) {
        if (IsWindowsAbsolutePath(fullPath))
          return fullPath;
        else return Rebuild('/', @"C:\", @"\");
      } else {
        if (IsWindowsAbsolutePath(fullPath))
          return Rebuild('\\', "/", "/");
        else return fullPath;
      }
    }
  }
}
